-- Broodlord Lashlayer
local bosstable = LibStub("LibBabble-Boss-3.0"):GetLookupTable()
local loadSuccess, errorMsg = StatusSubscribe:RegisterEncounter("broodlord",
	bosstable["Broodlord Lashlayer"],
	{
		healthtrack={[12017]=true},
		manatrack={},
		phases={[""] = "Engaged"},
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter= function(event, ...) if ((select(4,...)) == bosstable["Broodlord Lashlayer"]) or ((select(7, ...)) == bosstable["Broodlord Lashlayer"]) then return true end end,
	},
	{
		["ENCOUNTER_ENGAGE"] = function() EnterPhase("") end,
		["ALL_OUT_OF_COMBAT"] = function() DisableEncounter() end,
	}
)
if not loadSuccess then
	print("Load of "..bosstable["Broodlord Lashlayer"].." failed: "..StatusSubscribe.locale[errorMsg])
end

-- Chromaggus
loadSuccess, errorMsg = StatusSubscribe:RegisterEncounter("chromaggus",
	bosstable["Chromaggus"],
	{
		healthtrack={[14020]=true},
		manatrack={},
		phases={[""]="Engaged"},
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter=function(event,...) if ((select(4,...)) == bosstable["Chromaggus"]) or ((select(7,...)) == bosstable["Chromaggus"]) then return true end end,
	},
	{
		["ENCOUNTER_ENGAGE"] = function() EnterPhase("") TimerCreate("Sane players", "dcount", GetNumRaidMembers()) end,
		["UNIT_AURA"] = function() local sane = 0 for i=1, GetNumRaidMembers() do if not UnitAura("raid"..i, (GetSpellInfo(23174))) then sane=sane+1 end end TimerSet("Sane players", sane) end,
		["ALL_OUT_OF_COMBAT"] = function() DisableEncounter() end,
	}
)
if not loadSuccess then
	print("Load of "..bosstable["Chromaggus"].." failed: "..StatusSubscribe.locale[errorMsg])
end

-- Ebonroc
loadSuccess, errorMsg = StatusSubscribe:RegisterEncounter("ebonroc",
	bosstable["Ebonroc"],
	{
		healthtrack={[14601]=true},
		manatrack={},
		phases={[""]="Engaged"},
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter=function(event,...) if ((select(4,...)) == bosstable["Ebonroc"]) or ((select(7,...)) == bosstable["Ebonroc"]) then return true end end,
	},
	{
		["ENCOUNTER_ENGAGE"] = function() EnterPhase("") end,
		["ALL_OUT_OF_COMBAT"] = function() DisableEncounter() end,
	}
)
if not loadSuccess then
	print("Load of "..bosstable["Ebonroc"].." failed: "..StatusSubscribe.locale[errorMsg])
end

-- Firemaw
loadSuccess, errorMsg = StatusSubscribe:RegisterEncounter("firemaw",
	bosstable["Firemaw"],
	{
		healthtrack={[11983]=true},
		manatrack={},
		phases={[""]="Engaged"},
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter=function(event,...) if ((select(4,...)) == bosstable["Firemaw"]) or ((select(7,...)) == bosstable["Firemaw"]) then return true end end,
	},
	{
		["ENCOUNTER_ENGAGE"] = function() EnterPhase("") end,
		["ALL_OUT_OF_COMBAT"] = function() DisableEncounter() end,
	}
)
if not loadSuccess then
	print("Load of "..bosstable["Firemaw"].." failed: "..StatusSubscribe.locale[errorMsg])
end

-- Flamegor
loadSuccess, errorMsg = StatusSubscribe:RegisterEncounter("flamegor",
	bosstable["Flamegor"],
	{
		healthtrack={[11981]=true},
		manatrack={},
		phases={[""]="Engaged"},
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter=function(event,...) if ((select(4,...)) == bosstable["Flamegor"]) or ((select(7,...)) == bosstable["Flamegor"]) then return true end end,
	},
	{
		["ENCOUNTER_ENGAGE"]= function() EnterPhase("") end,
		["ALL_OUT_OF_COMBAT"] = function() DisableEncounter() end,
	}
)
if not loadSuccess then
	print("Load of "..bosstable["Broodlord Lashlayer"].." failed: "..StatusSubscribe.locale[errorMsg])
end

-- Nefarian
loadSuccess, errorMsg = StatusSubscribe:RegisterEncounter("nefarian",
	bosstable["Nefarian"],
	{
		healthtrack={[11583]=true},
		manatrack={},
		phases={["1"]="Drakonoids",["2"]="Ground",["3"]="Bone constructs"},
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter=function(event,...)
			if event == "COMBAT_LOG_EVENT_UNFILTERED" then
				local srcid = tonumber((select(3,...)):sub(9,12),16)
				local dstid = tonumber((select(6,...)):sub(9,12),16)
				if (srcid == 11583) or (dstid == 11583) then
					return true
				end
				if (srcid == 10162) or (dstid == 10162) then
					return true
				end
				if (srcid == 14265) or (dstid == 14265) then
					return true
				end
				if (srcid == 14261) or (dstid == 14261) then
					return true
				end
				if (srcid == 14263) or (dstid == 14263) then
					return true
				end
				if (srcid == 14302) or (dstid == 14302) then
					return true
				end
				if (srcid == 14262) or (dstid == 14262) then
					return true
				end
				if (srcid == 14264) or (dstid == 14264) then
					return true
				end
			elseif event == "CHAT_MSG_MONSTER_YELL" then
				local msg, sender = ...
				if sender == bosstable["Nefarian"] and msg == "Let the games begin!" then
					return true
				end
			end
		end,
	},
	{
		["ENCOUNTER_ENGAGE"] = function() EnterPhase("1") TimerCreate("Drakonoids slain", "ucount", 42) end,
		["COMBAT_LOG_EVENT_UNFILTERED"] = function(...)
			if ((select(2, ...)) == "UNIT_DIED") and (IsInPhase("1")) then
				local did = tonumber((select(6,...)):sub(9,12),16)
				local function drakkill()
					local value = TimerValue("Drakonoids slain")
					value = value+1
					TimerSet("Drakonoids slain", value)
					if value >= 42 then
						EnterPhase("2")
					end
				end
				if did == 14265 then
					drakkill()
					return
				end
				if did == 14261 then
					drakkill()
					return
				end
				if did == 14263 then
					drakkill()
					return
				end
				if did == 14302 then
					drakkill()
					return
				end
				if did == 14262 then
					drakkill()
					return
				end
				if did == 14264 then
					drakkill()
					return
				end
			end
			if (tonumber((select(6,...)):sub(9,12),16) == 14605) or (tonumber((select(6,...)):sub(9,12),16) == 14605) then
				EnterPhase("3")
			end
		end,
		["ALL_OUT_OF_COMBAT"] = function() DisableEnconter() end,
	}
)
if not loadSuccess then
	print("Load of "..bosstable["Nefarian"].." failed: "..StatusSubscribe.locale[errorMsg])
end

-- Razorgore
StatusSubscribe:RegisterEncounter("razorgore",
	bosstable["Razorgore the Untamed"],
	{
		healthtrack={[12435]=true,[12557]=false},
		manatrack={},
		phases={["1"]="Destroy the eggs", ["2"]="Kill Razorgore"},
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter=function(event,...)
			local sid = tonumber((select(3,...)):sub(9,12),16)
			local did = tonumber((select(6,...)):sub(9,12),16)
			if (sid == 14456) or (sid == 12557) or (sid == 12435) or (did == 14456) or (did == 12557) or (did == 12435) then
				return true
			end
		end,
	},
	{
		["ENCOUNTER_ENGAGE"] = function() EnterPhase("1") TimerCreate("Eggs left", "dcount", 30) end,
		["COMBAT_LOG_EVENT_UNFILTERED"] = function(...)
			if ((select(2,...)) == "SPELL_CAST_SUCCESS" and (select(9,...)) == 19873) and IsInPhase("1") then
				local value = TimerValue("Eggs left")
				value = value-1
				if value <= 0 then
					EnterPhase("2")
				end
			end
		end,
		["ALL_OUT_OF_COMBAT"] = function()
			DisableEncounter()
		end,
	}
)
if not loadSuccess then
	print("Load of "..bosstable["Razorgore the Untamed"].." failed: "..StatusSubscribe.locale[errorMsg])
end

-- Vaelastrasz
StatusSubscribe:RegisterEncounter("vael",
	bosstable["Vaelastrasz the Corrupt"],
	{
		healthtrack ={[13020]=true},
		manatrack={},
		phases={[""] = "Engaged"}
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter=function(event,...)
			local sid = tonumber((select(3,...)):sub(9,12),16)
			local did = tonumber((select(6,...)):sub(9,12),16)
			if sid == 13020 or did == 13020 then
				return true
			end
		end,
	},
	{
		["ENCOUNTER_ENGAGE"] = function() EnterPhase("") end,
		["ALL_OUT_OF_COMBAT"] = function() DisableEncounter() end,
	}
)
if not loadSuccess then
	print("Load of "..bosstable["Vaelastrasz the Corrupt"].." failed: "..StatusSubscribe.locale[errorMsg])
end