--load lbb
local bosstable = LibStub("LibBabble-Boss-3.0"):GetLookupTable()
local a = CreateFrame("Frame")
a:RegisterEvent("PLAYER_ENTERING_WORLD")
local playerbitmask
a:SetScript("OnEvent", function(self)
	playerbitmask = bit.band(UnitGUID("player"):sub(1,5),0x00F)
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
end)
--Venoxis
local loadSuccess, errorMsg = StatusSubscribe:RegisterEncounter("venoxis",
	bosstable["High Priest Venoxis"],
	{
		healthtrack={[14507]=true,[11373]=false},
		manatrack={},
		phases={["1"]="Troll form", ["2"] = "Snake form"},
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter=function(event,...)
			local sid = tonumber((select(3,...)):sub(9,12),16)
			local did = tonumber((select(6,...)):sub(9,12),16)
			if sid == 14507 or did == 14507 then
				return true
			end
		end,
	},
	{
		["COMBAT_LOG_EVENT_UNFILTERED"]=function(...)
			if IsInPhase("1") and (tonumber((select(3,...)):sub(9,12),16) == 14507) and (select(10,...)) == (GetSpellInfo(23861)) then
				EnterPhase("2")
			end
		end,
		["ENCOUNTER_ENGAGE"] = function() EnterPhase("1") end,
		["ALL_OUT_OF_COMBAT"] = function() DisableEncounter() end,
	}
)

if not loadSuccess then
	print("Load of "..bosstable["High Priest Venoxis"].." failed: "..StatusSubscribe.locale[errorMsg])
end

--Thekal
loadSuccess, errorMsg = StatusSubscribe:RegisterEncounter("thekal",
	bosstable["High Priest Thekal"],
	{
		healthtrack={[14509]=true,[11348]=true,[11347]=true},
		manatrack={},
		phases={["1"]="Troll form", ["2"]="Tiger form"},
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter=function(event,...)
			local sid = tonumber((select(3,...)):sub(9,12),16)
			local did = tonumber((select(6,...)):sub(9,12),16)
			local isSidThekal = (sid == 14509) or (sid == 11348) or (sid == 11347)
			local isDidThekal = (did == 14509) or (did == 11348) or (did == 11347)
			if (isSidThekal and (not isDidThekal)) or (isDidThekal and (not isSidThekal)) then
				return true
			end
		end,
	},
	{
		["COMBAT_LOG_EVENT_UNFILTERED"] = function(...)
			if tonumber((select(3,...)):sub(9,12),16) == 14509 then
				local spid = select(9,...)
				if spid == 24193 or spid == 24189 or spid == 8269 or spid == 24183 then
					EnterPhase("2")
				end
			end
		end,
		["CHAT_MSG_MONSTER_YELL"]= function(msg, sender)
			if sender == bosstable["High Priest Thekal"] and msg == "Shirvallah, fill me with your RAGE!" then
				EnterPhase("2")
			end
		end,
		["ENCOUNTER_ENGAGE"] = function() EnterPhase("1") end,
		["ALL_OUT_OF_COMBAT"] = function() DisableEncounter() end,
	}
)

if not loadSuccess then
	print("Load of "..bosstable["High Priest Thekal"].." failed: "..StatusSubscribe.locale[errorMsg])
end

loadSuccess, errorMsg = StatusSubscribe:RegisterEncounter("mandokir",
	bosstable["Bloodlord Mandokir"],
	{
		healthtrack={[11382]=true,[14988]=true},
		manatrack={},
		phases={[""]="Engaged"},
	},
	{
		events={"COMBAT_LOG_EVENT_UNFILTERED"},
		filter=function(event,...)
			local sid = tonumber((select(3,...)):sub(9,12),16)
			local did = tonumber((select(6,...)):sub(9,12),16)
			if sid == 11382 or did == 11382 or sid == 14988 or did == 14988 then
				return true
			end
		end,
	},
	{
		["COMBAT_LOG_EVENT_UNFILTERED"] = function(...)
			if (select(2,...)) == "UNIT_DIED" and bit.band((select(6,...)):sub(1,5), 0x00F) == playerbitmask then
				local value = TimerValue("Kills until level up")
				value = value+1
				if value == 3 then
					TimerSet("Kills until level up", 0)
					TimerSet("Levels gained", TimerValue("Levels gained")+1)
				else
					TimerSet("Kills until level up", 0)
				end
			end
		end,
		["ENCOUNTER_ENGAGE"]=function() EnterPhase("") TimerCreate("Kills until level up", "ucount", 3) TimerCreate("Levels gained", "ucount", 99) end,
		["ALL_OUT_OF_COMBAT"] = function() DisableEncounter() end,
	}
)
if not loadSuccess then
	print("Load of "..bosstable["Bloodlord Mandokir"].." failed: "..StatusSubscribe.locale[errorMsg])
end